<?php
/*
Plugin Name: AStat
Version: 1.1.1
Description: Statistiques avancées
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=172
*/

/* ----------------------------------------------------------------------

Author : grum@grum.dnsalias.com :: http://photos.grum.dnsalias.com

1.0   - 15/09/07 - 1ère version
1.0.1 - 15/09/07 - correction de l'import, l'usage des stats nativements en place dans PWG fonctionnent :)
1.1.0 - 16/09/07 + Géolocalisation des IP dans le template AStat_by_ip.tpl [par VDigital http://forum.phpwebgallery.net/profile.php?id=1227]
                 + Paramétrage de la période affichée par défaut dans l'onglet "par période"
                 + Paramétrage des couleurs : avoir un aperçu de la couleur en temps réél (pas indispensable mais çà fait toujours bien ^^;)
                 + voir la vignette représentant la catégorie quand on la survole (stats par catégories)
		 + pouvoir trier différement les stats par catégories : %page / %image / images vues ; paramétrage par défaut à gérer
		 - désactiver la fonction d'import => plus nécessaire dans les version qui suivent, la 1.0.1 gérant très bien le sujet
		 + gérer la config dans la table CONFIG_TABLE => procédure de désinstallation à prévoir ?
		 - correction d'un bug sur la requete par catégorie (préfixe des tables était en dur...)
		 + avoir un onglet "par images" fonctionnant comme l'onglet "par catégorie" (restitue : Nb Vue/Nb IP + thumb)
1.1.1 - 17/09/07 + révision du template "AStat_by_ip.tpl" ([géolocalisation] placé devant l'IP, c'est plus joli :))
		 - correction du problème cité dans [http://forum.phpwebgallery.net/viewtopic.php?pid=71127#p71127] lors de l'installation du plugin
		 - corriger le problème cité dans [http://forum.phpwebgallery.net/viewtopic.php?pid=71128#p71128] sur les index inexistants
		 - correction d'un bug sur l'extension des thumb [http://forum.phpwebgallery.net/viewtopic.php?pid=71088#p71088]
:: TO DO
	* gérer / filtrer les IP correspondant à des users sur la page IP
	* correction d'un bug sur les requetes comptant le nombre d'images (ne pas prendre en compte dans history les image_id = 0 ????)
	* prendre en compte remarques du [http://forum.phpwebgallery.net/viewtopic.php?pid=71076#p71076]
			* fonction de resynchronisation de la table historique (category_id avec celle de IMAGE_TABLE)
			* stat par catégorie, si pas de catégorie, afficher la section à la place
	* gérer une procédure d'installation (config par défaut) / désinstallation (supprimer la config) proprement
	* ajouter une 4ème barre "catégorie" sur stats par période [http://forum.phpwebgallery.net/viewtopic.php?pid=71161#p71161]

   ---------------------------------------------------------------------- */
// pour faciliter le debug :o)
// ini_set('error_reporting', E_ALL);
// ini_set('display_errors', true);

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('ASTAT_DIR' , basename(dirname(__FILE__)));
define('ASTAT_PATH' , PHPWG_PLUGINS_PATH . ASTAT_DIR . '/');

define('ASTAT_VERSION' , '1.1.1');


class AStat_Plugin
{ 
    var $my_config;
    var $list_periods = array('global', 'all', 'year', 'month', 'day');
    var $list_sortcat = array('page', 'picture', 'nbpicture');
    var $list_sortimg = array('picture', 'catname');

	/* charge la configuration dans le fichier data.dat */
	function load_config()
	{
		$sql="SELECT value FROM ".CONFIG_TABLE." WHERE param = 'AStat_config'";
		$result=pwg_query($sql);	   
		if($result)
	        {
			$row=mysql_fetch_row($result);
			if(is_string($row[0])) 
	            	{
				$c = unserialize($row[0]);
	            		$this->my_config = $c;
			}
	        }

		/* affectation des valeurs par défaut */	 
	        if(!isset($this->my_config['AStat_BarColor_Pages']))
	        { $this->my_config['AStat_BarColor_Pages'] = '6666ff'; }

	        if(!isset($this->my_config['AStat_BarColor_Img']))
	        { $this->my_config['AStat_BarColor_Img'] = '66ff66'; }

	        if(!isset($this->my_config['AStat_BarColor_IP']))
	        { $this->my_config['AStat_BarColor_IP'] = 'ff6666'; }

	        if(!isset($this->my_config['AStat_MouseOverColor']))
	        { $this->my_config['AStat_MouseOverColor'] = '303030'; }

	        if(!isset($this->my_config['AStat_NpIPPerPages']))
	        { $this->my_config['AStat_NpIPPerPages'] = '25'; }

	        if(!isset($this->my_config['AStat_NpCatPerPages']))
	        { $this->my_config['AStat_NpCatPerPages'] = '50'; }

	        if(!isset($this->my_config['AStat_MaxBarWidth']))
	        { $this->my_config['AStat_MaxBarWidth'] = '400'; }

	        if(!isset($this->my_config['AStat_default_period']))
	        { $this->my_config['AStat_default_period'] = 'global'; /* global, all, year, month, day */ }

	        if(!isset($this->my_config['AStat_ShowThumbCat']))
            	{ $this->my_config['AStat_ShowThumbCat'] = 'false'; }   

	        if(!isset($this->my_config['AStat_DefaultSortCat']))
            	{ $this->my_config['AStat_DefaultSortCat'] = 'page'; } /* page, picture, nbpicture */

	        if(!isset($this->my_config['AStat_ShowThumbImg']))
            	{ $this->my_config['AStat_ShowThumbImg'] = 'false'; }   

	        if(!isset($this->my_config['AStat_DefaultSortImg']))
            	{ $this->my_config['AStat_DefaultSortImg'] = 'picture'; } /* picture, catname */

	        if(!isset($this->my_config['AStat_NbImgPerPages']))
	        { $this->my_config['AStat_NbImgPerPages'] = '100'; }

	        //$this->save_config();
	        
	}

	/* sauvegarde de la configuration dans la table config */
	function save_config()
	{
	 $sql="REPLACE INTO ".CONFIG_TABLE." VALUES('AStat_config', '".serialize($this->my_config)."', '')"; 
	 $result=pwg_query($sql);
	 if($result) { return true; } else { return false; }
	}

	/* intégration du plugin dans l'interface d'administration */
	function plugin_admin_menu($menu)
	{
	 array_push($menu,
	            array(
	                'NAME' => 'AStat',
	                'URL' => get_admin_plugin_menu_link(dirname(__FILE__).'/admin/AStat_admin.php')
	                 ));
	 return $menu;
	}

	/* modifie la feuille de style pour affichage des stats */
	function Modifie_CSS()
	{
	  global $template;

	  $text = ".AStatBar1, .AStatBar2, .AStatBar3, .AStatBarX { 
			border:0px; 
			height:8px;
			display: block;
			margin:0px;
			padding:0px;
			left:0;
			position:relative;
			}
		   .AStatBar1 {	background-color:#".$this->my_config['AStat_BarColor_Pages']."; top:3px;  }
		   .AStatBar2 {	background-color:#".$this->my_config['AStat_BarColor_Img']."; top:-3px; }
		   .AStatBar3 {	background-color:#".$this->my_config['AStat_BarColor_IP']."; top:-3px;} 
		   .AStatBarX {	background-color:none; top:-3px; height:1px; } 
		   .StatTableRow:hover { background-color:#".$this->my_config['AStat_MouseOverColor']."; }
		   .formtable { text-align:left; display:block; } 
		   .window_thumb {
			position:absolute;
			border: none;
			background: none;
			left:0;
			top:0;
			margin:0px;
			padding:0px;
			z-index:100;
			overflow:hidden;
			visibility:hidden; }	
		    .img_thumb {
			border: solid 3px #ffffff;
			background: #000000;
			margin:0px;
			padding:0px; }	
		";	  
	  if($text!="")
	  {
	    $template->assign_block_vars('head_element', array('CONTENT' => '<style type="text/css"> '.$text.' </style>'));
	  }
	}

}
$obj = new AStat_Plugin();
$obj->load_config();

 
add_event_handler('get_admin_plugin_menu_links', array(&$obj, 'plugin_admin_menu') ); 
add_event_handler('loc_end_page_header', array(&$obj, 'Modifie_CSS'));

set_plugin_data($plugin['id'], $obj)

?>
